<?php
namespace Backend\Model;
use Backend\Model\BackendModel;

/**
 * 会员模型类
 * @author: duanbin
 * @时间: 2016年10月9日 下午3:34:41
 */
class CloudstorageModel extends BackendModel{
	//关联的表名
	protected $trueTableName = "agent_cloudstorage_business";

	//搜索条件字段
	public $searchable = [
		"state" => [
			"display_name" => "状态",
			"html_type" => "select",
			"data" => [
				1 => "正常",
				2 => "已删除",
				3 => "已过期",
				4 => "失败"
			]
		],
		"overdue_time" => [
			"display_name" => "到期时间",
			"html_type" => "date",
			"start_name" => "_start",
			"end_name" => "_end"
		],
		"key" => [
			"api_bid" => "业务编号",
			"login_name" => "登陆名",
			"wwdz" => "外网IP",
			"nwdz" => "内网IP"
		]
	];
	//排序字段
	public $sortable = [
		"id" => [
			"display_name" =>"ID",
			"sortable" => true
		],
		"user_id" => [
			"display_name" =>"用户id",
			"sortable" => false
		],
		"login_name" => [
			"display_name" =>"登陆名",
			"sortable" => false
		],
		"api_bid" => [
			"display_name" =>"业务编号",
			"sortable" => true
		],
		"ywbs" => [
			"display_name" =>"业务标识",
			"sortable" => false
		],
		"product_name" => [
			"display_name" => "产品名称",
			"sortable" => false
		],
		"open_time" => [
			"display_name" => "开通时间",
			"sortable" => true
		],
		"overdue_time" => [
			"display_name" => "到期时间",
			"sortable" => true
		],
		"free_trial" => [
			"display_name" => "购买/试用",
			"sortable" => false
		],
		"model" => [
			"display_name" => "模式",
			"sortable" => false
		],
		"quota" => [
			"display_name" => "容量",
			"sortable" => false
		],
		"flow" => [
			"display_name" => "流量",
			"sortable" => false
		],
		"dk" => [
			"display_name" => "带宽",
			"sortable" => false
		],
		"dk_overdue_time" => [
			"display_name" => "带宽到期时间",
			"sortable" => false
		],
		"area_code" => [
			"display_name" => "地区",
			"sortable" => false
		],
		"state" => [
			"display_name" => "状态",
			"sortable" => false
		],
		"beizhu" => [
			"display_name" => "备注",
			"sortable" => false
		],
		"admin_beizhu" => [
			"display_name" => "管理员备注",
			"sortable" => false
		]
	];
	
	/**
	 * 获取搜索条件所需要的数据,可以实现getFillData方法,将一些需要的数据复给$this->fill_data,例如本类的getFillData()方法
	 * @时间: 2016年10月11日 下午3:03:09
	 * @author: duanbin
	 * @param array $fill_data
	 * @return null
	 */
	public function getSearchable($fill_data = []){
		if (empty($fill_data)) {
			return $this->fillSearchable($this->fillData);
		}else {
			return $this->fillSearchable($fill_data);
		}
	}
	
	
	/**
	 * 获取搜索条件需要的数据
	 * @时间: 2016年10月12日 下午2:54:05
	 * @author: duanbin
	 * @return $this
	 */
	public function getFillData(){
		/** 这里注意返回的一定是一个数组,并且数组的key一定是与searchable数组的key相同 */
		//区域数据
		$fill_data["area_code"] = D("Common/Region")->where(array("state"=>1))->getAll("region_code as k,region_name as v");
		$fill_data["model"] = ["1"=>"流量模式","2"=>"带宽模式","3"=>"切换中"];
		$fill_data["free_trial"] = ["0"=>"购买","1"=>"试用"];
		$fill_data["state"] = [1 => "正常",2 => "已删除",3 => "已过期",4 => "失败",5 => "未获取信息"];
		//父类里继承来的属性
		$this->fillData = $fill_data;
		return $this;
	}

	/**********************************新增更新回调/开始***********************************/
	/**
	 * 插入数据之前的回调
	 * @时间: 2016年10月17日 上午11:28:21
	 * @author: duanbin
	 * @param $data
	 * @param $options
	 */
	protected function _before_insert(&$data, $options){}
	
	/**
	 * 插入成功后的回调
	 * @时间: 2016年10月17日 上午11:28:50
	 * @author: duanbin
	 * @param $data
	 * @param $options
	 */
	protected function _after_insert($data, $options){}
	
	/**
	 * 更新数据之前做的操作
	 * @时间: 2016年10月17日 上午11:26:36
	 * @author: duanbin
	 * @param $data
	 * @param $options
	 */
	protected function _before_update(&$data, $options){}
	
	/**
	 * 更新之后做的操作
	 * @时间: 2016年10月17日 上午11:27:09
	 * @author: duanbin
	 * @param $data
	 * @param $options
	 */
	protected function _after_update($data, $options){}
	/**********************************新增更新回调/结束***********************************/
}
