<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2017/1/10
 * Time: 16:22
 */

namespace Frontend\Model;

use Frontend\Model\BusinessModel;
use Common\Data\StateData as SD;
use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;

/**
 * 对象存储
 * @date: 2018年10月31日10:58:09
 * @author: Guopeng
 */
class CloudstorageModel extends BusinessModel{

	protected $trueTableName = 'agent_cloudstorage_business';

	/**
	 * 页面获取对象存储价格
	 * @date: 2018年11月1日10:05:52
	 * @author: Guopeng
	 * @return array
	 */
	public function getPrice(){
		$return = array();
		$d = request();
		$p = new ProductModel();
		$t = $d["model"]+0;//计算价格类型
		$dz = 1;//是否打折
		if($t === 1){//购买(流量模式)
			$type = $d["type"]+0;//价格模式
			if($type === 1){//容量价格
				$neicun = $d["neicun"] + 0;
				$selecttime = $d["selecttime"] + 0;
				$neicun_w["product_id"] = 318;
				$neicun_w["month"] = 1;
				$neicun_w["type"] = 0;
				$neicun_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_neicun = $p->get_database_price($neicun_w);
				if(!$price_neicun){
					$return["msg"] = "价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $neicun * $selecttime * $price_neicun["product_price"];
			}elseif($type == 2){//流量价格
				$traffic = $d["traffic"] + 0;
				$ttype = 1;
				if(500 < $traffic && $traffic <= 1024){
					$ttype = 2;
				}elseif(1024 < $traffic && $traffic <= 10240){
					$ttype = 3;
				}elseif(10240 < $traffic){
					$ttype = 4;
				}
				$t_w["product_id"] = 318;
				$t_w["month"] = $ttype;
				$t_w["type"] = 0;
				$t_w['note_appended'] = ['eq',"cloudstorage.ll.price"];
				$price_t = $p->get_database_price($t_w);
				if(!$price_t){
					$return["msg"] = "价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $traffic * $price_t["product_price"];
			}else{
				$price = 0;
			}
		}elseif($t === 2){//购买(带宽模式)
			$type = $d["type"]+0;//价格模式
			if($type == 1){//容量价格
				$neicun = $d["neicun"] + 0;
				$selecttime = $d["selecttime"] + 0;
				$neicun_w["product_id"] = 318;
				$neicun_w["month"] = 1;
				$neicun_w["type"] = 0;
				$neicun_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_neicun = $p->get_database_price($neicun_w);
				if(!$price_neicun){
					$return["msg"] = "价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $neicun * $selecttime * $price_neicun["product_price"];
			}elseif($type == 2){//带宽价格
				$bw = $d["bw"] + 0;
				$bwtime = $d["bwtime"] + 0;
				//购买优惠
				if($bwtime == 12){
					$bwtime = 10;
				}elseif($bwtime == 24){
					$bwtime = 20;
				}elseif($bwtime == 36){
					$bwtime = 30;
				}
				$bw_w["product_id"] = 318;
				$bw_w["month"] = 1;
				$bw_w["type"] = 0;
				$bw_w['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_bw = $p->get_database_price($bw_w);
				if(!$price_bw){
					$return["msg"] = "带宽价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $bw * $bwtime * $price_bw["product_price"];
			}else{
				$price = 0;
			}
		}elseif($t === 3){//转正
			$dz = 0;
			$type = $d["billtype"]+0;//价格模式
			$rltime = $d["rltime"]+0;
			$rlsize = $d["rlsize"]+0;
			$rlsize = 5;
			$flow = $d["flow"]+0;
			$dksize = $d["dksize"]+0;
			$dktime = $d["dktime"]+0;
			if($rltime == 12){
				$rltime = 10;
			}elseif($rltime == 24){
				$rltime = 20;
			}elseif($rltime == 36){
				$rltime = 30;
			}
			$rl_w["product_id"] = 318;
			$rl_w["month"] = 1;
			$rl_w["type"] = 0;
			$rl_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
			$price_rl = $p->get_database_price($rl_w);
			if(!$price_rl){
				$return["msg"] = "价格获取失败！";
				$return["status"] = false;
				return $return;
			}
			$price = $rlsize * $rltime * $price_rl["product_price"];
			if($type == 2){
				//转正优惠
				if($dktime == 12){
					$dktime = 10;
				}elseif($dktime == 24){
					$dktime = 20;
				}elseif($dktime == 36){
					$dktime = 30;
				}
				$bw_w["product_id"] = 318;
				$bw_w["month"] = 1;
				$bw_w["type"] = 0;
				$bw_w['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_bw = $p->get_database_price($bw_w);
				if(!$price_bw){
					$return["msg"] = "带宽价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $price + $dksize * $dktime * $price_bw["product_price"];
			}
		}elseif($t === 4){//续费
			$dz = 0;
			$type = $d["type"]+0;//价格模式
			if($type == 1){//容量价格1
				$rl = $d["neicun"] + 0;
				$selecttime = $d["selecttime"] + 0;
				//续费优惠
				if($selecttime == 12){
					$selecttime = 10;
				}elseif($selecttime == 24){
					$selecttime = 20;
				}elseif($selecttime == 36){
					$selecttime = 30;
				}
				$rl_w["product_id"] = 318;
				$rl_w["month"] = 1;
				$rl_w["type"] = 0;
				$rl_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_rl = $p->get_database_price($rl_w);
				if(!$price_rl){
					$return["msg"] = "容量价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $rl * $selecttime * $price_rl["product_price"];
			}elseif($type == 2){//容量价格2
				$rl = $d["neicun"] + 0;
				$selecttime = $d["selecttime"] + 0;
				//续费优惠
				if($selecttime == 12){
					$selecttime = 10;
				}elseif($selecttime == 24){
					$selecttime = 20;
				}elseif($selecttime == 36){
					$selecttime = 30;
				}
				$rl_w["product_id"] = 318;
				$rl_w["month"] = 1;
				$rl_w["type"] = 0;
				$rl_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_rl = $p->get_database_price($rl_w);
				if(!$price_rl){
					$return["msg"] = "容量价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $rl * $selecttime * $price_rl["product_price"];
			}elseif($type == 3){//带宽价格
				$bw = $d["bw"] + 0;
				$bwtime = $d["bwtime"] + 0;
				//续费优惠
				if($bwtime == 12){
					$bwtime = 10;
				}elseif($bwtime == 24){
					$bwtime = 20;
				}elseif($bwtime == 36){
					$bwtime = 30;
				}
				$bw_w["product_id"] = 318;
				$bw_w["month"] = 1;
				$bw_w["type"] = 0;
				$bw_w['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_bw = $p->get_database_price($bw_w);
				if(!$price_bw){
					$return["msg"] = "价格获取失败！";
					$return["status"] = false;
					return $return;
				}
				$price = $bw * $bwtime * $price_bw["product_price"];
			}else{
				$price = 0;
			}
		}else{
			$dz = 0;
			$price = 0;
		}
		$discount = 1;
		if($dz){
			if(session('?user_id') && $dz){
				$user = new MemberModel();
				$user_id = session('user_id');
				$user_level = $user->get_user_level($user_id,23);
				if($user_level["discount"] > 0){
					$discount = $user_level["discount"];
				}
			}
		}
		$price = ceil($price * $discount * 100)/100;
		$return["info"] = $price;
		$return["status"] = true;
		return $return;
	}

	/**
	 * 计算快云存储价格
	 * @date: 2018年11月7日16:12:08
	 * @author: Guopeng
	 * @param $data
	 * @return string
	 */
	public function CalculatedPrice($data){
		$type = $data["type"];//类型
		$product = new ProductModel();
		$price = 0;
		if($type == 1){
			$yid = $data["yid"];//购买期限
			$model = $data["model"];//模式
			$quota = $data["quota"];//容量
			/*获取容量价格*/
			$q_where["product_id"] = 318;
			$q_where["month"] = 1;
			$q_where["type"] = 0;
			$q_where['note_appended'] = ['eq',"cloudstorage.nc.price"];
			$price_q = $product->get_database_price($q_where);
			if($model == 1){
				$flow = $data["flow"];//流量
				$f_month = 1;
				if($flow > 500 && $flow <= 1024){
					$f_month = 2;
				}elseif($flow > 1024 && $flow <= 10240){
					$f_month = 3;
				}elseif($flow > 10240){
					$f_month = 4;
				}
				$f_where["product_id"] = 318;
				$f_where["month"] = $f_month;
				$f_where["type"] = 0;
				$f_where['note_appended'] = ['eq',"cloudstorage.ll.price"];
				$price_f = $product->get_database_price($f_where);
				$price = ceil(($quota * $price_q["product_price"] * $yid + $flow * $price_f["product_price"]) * 100)/100;
			}elseif($model == 2){
				$bw = $data["bandwidth"];//带宽
				$bwtime = $data["bandTime"];//带宽时限
				//购买优惠
				if($bwtime == 12){
					$bwtime = 10;
				}elseif($bwtime == 24){
					$bwtime = 20;
				}elseif($bwtime == 36){
					$bwtime = 30;
				}
				$b_where["product_id"] = 318;
				$b_where["month"] = 1;
				$b_where["type"] = 0;
				$b_where['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_b = $product->get_database_price($b_where);
				$price = ceil(($quota * $price_q["product_price"] * $yid + $bw * $price_b["product_price"] * $bwtime)*100)/100;
			}
		}elseif($type == 2){//续费
			$yid = $data["yid"];//购买期限
			$model = $data["model"];//模式
			if($yid == 12){
				$yid = 10;
			}elseif($yid == 24){
				$yid = 20;
			}elseif($yid == 36){
				$yid = 30;
			}
			if($model == 1){
				$quota = $data["quota"];//容量
				$q_where["product_id"] = 318;
				$q_where["month"] = 1;
				$q_where["type"] = 0;
				$q_where['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_q = $product->get_database_price($q_where);
				$price = ceil($quota * $price_q["product_price"] * $yid * 100)/100;
			}elseif($model == 2){
				$bw = $data["dk"];//带宽
				$b_where["product_id"] = 318;
				$b_where["month"] = 1;
				$b_where["type"] = 0;
				$b_where['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_b = $product->get_database_price($b_where);
				$price = ceil($bw * $price_b["product_price"] * $yid * 100)/100;
			}elseif($model == 3){
				$quota = $data["quota"];//容量
				$bw = $data["dk"];//带宽
				$q_where["product_id"] = 318;
				$q_where["month"] = 1;
				$q_where["type"] = 0;
				$q_where['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_q = $product->get_database_price($q_where);
				$b_where["product_id"] = 318;
				$b_where["month"] = 1;
				$b_where["type"] = 0;
				$b_where['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_b = $product->get_database_price($b_where);
				$price = ceil(($quota * $price_q["product_price"] + $bw * $price_b["product_price"]) * $yid * 100)/100;
			}
		}elseif($type == 4){//转正
			$yid = $data["yid"];//转正期限
			$model = $data["model"];//模式
			$quota = $data["quota"];//容量
			//购买优惠
			if($yid == 12){
				$yid = 10;
			}elseif($yid == 24){
				$yid = 20;
			}elseif($yid == 36){
				$yid = 30;
			}
			/*获取容量价格*/
			$q_where["product_id"] = 318;
			$q_where["month"] = 1;
			$q_where["type"] = 0;
			$q_where['note_appended'] = ['eq',"cloudstorage.nc.price"];
			$price_q = $product->get_database_price($q_where);
			if($model == 1){
				$price = ceil($quota * $price_q["product_price"] * $yid * 100)/100;
			}elseif($model == 2){
				$bw = $data["bandwidth"];//带宽
				$bwtime = $data["bandTime"];//带宽时限
				//购买优惠
				if($bwtime == 12){
					$bwtime = 10;
				}elseif($bwtime == 24){
					$bwtime = 20;
				}elseif($bwtime == 36){
					$bwtime = 30;
				}
				$b_where["product_id"] = 318;
				$b_where["month"] = 1;
				$b_where["type"] = 0;
				$b_where['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_b = $product->get_database_price($b_where);
				$price = ceil(($quota * $price_q["product_price"] * $yid + $bw * $price_b["product_price"] * $bwtime)*100)/100;
			}
		}elseif($type == 3){
			$yid = $data["yid"];//购买期限
			$model = $data["model"];//模式
			$size = $data["size"];//增值大小
			if($model == 1){//增值容量
				$q_where["product_id"] = 318;
				$q_where["month"] = 1;
				$q_where["type"] = 0;
				$q_where['note_appended'] = ['eq',"cloudstorage.nc.price"];
				$price_q = $product->get_database_price($q_where);
				$price = ceil(($size * $price_q["product_price"] * $yid) * 100)/100;
			}elseif($model == 3){//增值流量
				$f_month = 1;
				if($size > 500 && $size <= 1024){
					$f_month = 2;
				}elseif($size > 1024 && $size <= 10240){
					$f_month = 3;
				}elseif($size > 10240){
					$f_month = 4;
				}
				$f_where["product_id"] = 318;
				$f_where["month"] = $f_month;
				$f_where["type"] = 0;
				$f_where['note_appended'] = ['eq',"cloudstorage.ll.price"];
				$price_f = $product->get_database_price($f_where);
				$price = ceil(($size * $price_f["product_price"]) * 100)/100;
			}elseif($model == 2){//增值带宽
				$b_where["product_id"] = 318;
				$b_where["month"] = 1;
				$b_where["type"] = 0;
				$b_where['note_appended'] = ['eq',"cloudstorage.dk.price"];
				$price_b = $product->get_database_price($b_where);
				$price = ceil($size * $price_b["product_price"] * $yid * 100)/100;
			}
		}else{
			$price = 0;
		}
		return number_format($price,2,".","");
	}

	/**
	 * 对象存储购买/试用
	 * @date: 2018年11月6日10:55:42
	 * @author: Guopeng
	 * @return bool|void
	 */
	public function buy(){
		$data = request();
		$model = $data["model"]+0;
		$selecttime = $data["selecttime"]+0;
		$neicun = $data["neicun"]+0;
		$liuliang = $data["traffic"]+0;
		$bw = $data["bw"]+0;
		$bwtime = $data["bwtime"]+0;
		$free_trial = $data["isTest"]+0;
		$uid = session("user_id");
		$login_name = session("login_name");
		$buy = array();
		$buy["type"] = GD::TID_BUY;
		if($model == 2){
			$free_trial = 0;
		}
		if($free_trial == 0){
			$buy["free_trial"] = 0;
			$buy["yid"] = $selecttime;
			$buy["quota"] = $neicun;
			if($selecttime <= 0){
				$this->setError("请选择容量时长！");
				return false;
			}
			if($neicun < 5){
				$this->setError("容量最小5G！");
				return false;
			}
			if($model == 2){
				if($bw <= 0){
					$this->setError("带宽最低1M");
					return false;
				}
				if($bwtime <= 0){
					$this->setError("请选择带宽时长！");
					return false;
				}
				if($bwtime > $selecttime){
					$this->setError("带宽时长不能超过容量时长！");
					return false;
				}
				$buy["model"] = 2;
				$buy["bandwidth"] = $bw;
				$buy["bandTime"] = $bwtime;
			}elseif($model == 1){
				$buy["model"] = 1;
				$buy["flow"] = $liuliang;
			}else{
				$this->setError("请选择计费模式！");
				return false;
			}
		}else{
			$buy["model"] = 1;
			$buy["free_trial"] = $free_trial = 1;
			$buy["flow"] = 0;
			$buy["quota"] = 5;
		}
		$api_config = WebSiteConfig(2);//获取网站配置
		$api_access = $api_config["api_access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 封装订单参数信息
		$datarray = array(
			"user_id" => $uid,
			"login_name" => $login_name,
			'product_type' => 23,
			'product_id' => 318,
			'product_name' => "对象存储",
			"free_trial" => $free_trial, // 购买或者试用
			"order_time" => $selecttime,
			"order_type" => SD::NEW_ORDER,
			"create_time" => date('Y-m-d H:i:s'),
			"complete_time" => date('Y-m-d H:i:s'), // 完成时间
			"state" => SD::FAILURE_ORDER,  // 订单状态   成功
			"area_code" => 4001,//地区编号
			"order_quantity" => 1,
			"charge" => 0,
			"access" => $api_access
		);
		//执行录入订单、购买方法
		$order = new OrderModel();
		$oid = $order->cloudstorage_order_do_entry($datarray,$buy);
		if($oid < 0){//小于0就是错误返回信息
			$this->setError(business_code($oid));
			return false;
		}
		return $this->api_buy($oid,$buy);
	}

	/**
	 * 对象存储购买/试用接口调用
	 * @date: 2018年11月6日10:55:42
	 * @author: Guopeng
	 * @param int $oid 订单号
	 * @param array $buy 购买信息
	 * @return bool
	 */
	public function api_buy($oid,$buy){
		$order = new OrderModel();
		$order_info = $order->order_find($oid);
		$api_access = $order_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$uid = $order_info['user_id'];
		//参数
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = GD::TID_BUY;
		$yid = $buy['yid'];
		$area_code = 4001;
		$model = $buy['model'];
		$gmsl = 1;
		$quota = $buy['quota'];
		$log = "ptype:{$ptype}-tid:{$tid}-yid:{$yid}-area_code:{$area_code}-gmsl:{$gmsl}-quota:{$quota}-model:{$model}";
		if($model == 1 && $buy['free_trial'] == 1){ //试用
			$tid = GD::TID_TRY;
			$log = "ptype:{$ptype}-tid:{$tid}-area_code:{$area_code}-gmsl:{$gmsl}-quota:{$quota}";
		}
		$data = array();
		if($model == 2){
			$data["bandwidth"] = $buy["bandwidth"];
			$data["bandTime"] = $buy["bandTime"];
			$log = $log."-bandwidth:{$data["bandwidth"]}-bandTime:{$data["bandTime"]}";
		}else{
			$data["flow"] = $buy["flow"];
			$log = $log."-flow:{$data["flow"]}";
		}
		try{
			if($tid == 10){  //试用
				$result = $transaction->cloudstorage_try($quota,$buy["flow"]);
				api_log($uid,$log,$result,$order_info['order_log']."-access:".$api_access);
			}else{ //购买
				$result = $transaction->cloudstorage_buy($yid,$model,$quota,$data);
				api_log($uid,$log,$result,$order_info['order_log']."-access:".$api_access);
			}
		}catch(\Exception $e){
			// 调用接口试用失败修改订单表
			$dataarray = array(
				"complete_time" => date('Y-m-d H:i:s'),
				"order_log" => $order_info ['order_log']."-接口调用失败",
				"state" => SD::FAILURE_ORDER
			);
			$order->order_edit($oid,$dataarray);
			api_log($uid,$log,$e->getMessage(),$order_info['order_log']."-接口调用失败-access:".$api_access);
			$this->setError(business_code(-9));
			return false;//接口调用失败
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			$dataarray = array(
				"api_id" => $xstr['info']['did'],
				"complete_time" => date('Y-m-d H:i:s'),
				"state" => $tid == 10 ? SD::EXAMINE_ORDER : SD::PAYMENT_ORDER
			);
			// 修改订单表
			if($order->order_edit($oid,$dataarray)){
				return true;
			}else{
				$dataarray = array(
					"api_id" => $xstr['info']['did'],
					"complete_time" => date('Y-m-d H:i:s'),
					"order_log" => $order_info ['order_log']."-接口调用成功，订单表修改失败",
					"state" => SD::FAILURE_ORDER
				);
				$order->order_edit($oid,$dataarray);
				$this->setError(business_code(-7));
				return false; // 订单表修改失败
			}
		}else{
			// 调用接口试用失败修改订单表
			$dataarray = array(
				"complete_time" => date('Y-m-d H:i:s'),
				"order_log" => $order_info ['order_log']."-接口调用错误",
				"state" => SD::FAILURE_ORDER
			);
			$order->order_edit($oid,$dataarray);
			// 修改订单表
			$this->setError(business_code($xstr['code']));
			return false;
		}
	}

	/**
	 * 对象存储开通
	 * @date: 2018年11月9日15:39:45
	 * @author: Guopeng
	 * @param bool $m true：获取订单信息，false：开通操作
	 * @return bool
	 */
	public function open($m){
		$order = new OrderModel();
		$product = new ProductModel();
		$data = request();
		$uid = session("user_id");
		$oid = $data['order_id'] + 0;
		// 获取订单信息
		$o_info = $order->order_find($oid);
		if(!$o_info || $o_info['user_id'] != $uid){
			$return["msg"] = "业务不存在或不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($o_info['state'] != SD::PAYMENT_ORDER){
			if($o_info['state'] == SD::SUCCESS_ORDER){
				$return["msg"] = "该订单已开通，无需重复开通！";
				$return["status"] = false;
				return $return;
			}elseif($o_info['state'] == SD::FAILURE_ORDER){
				$return["msg"] = "失败订单无法开通！";
				$return["status"] = false;
				return $return;
			}else{
				$return["msg"] = "订单状态错误！";
				$return["status"] = false;
				return $return;
			}
		}
		if($m){
			$return["info"] = $o_info;
			$return["status"] = true;
			return $return;
		}
		$api_access = $o_info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 获取产品信息
		/*$p_info = $product->get_product($o_info["product_id"]);//对象存储318
		if(!$p_info){
			$return["msg"] = "产品信息获取失败！";
			$return["status"] = false;
			return $return;
		}*/
		//快云存储业务表
		$cloudstorage = array(
			"user_id" => $uid,
			"login_name" => $o_info['login_name'],
			"product_id" => $o_info['product_id'],
			"product_name" => $o_info['product_name'],
			"create_time" => current_date(),
			"buy_time" => $o_info['order_time'],
			"open_time" => current_date(),
			"overdue_time" => add_dates(current_date(),$o_info['order_time']),
			"free_trial" => $o_info['free_trial'],
			"des" => "对象存储",
			"state" => SD::NOTGET,//对象存储开通，未获取业务信息状态：5
			"mail_state" => 0,
			"area_code" => $o_info['area_code'],
			'note_appended' => "会员编号:".$uid."-开通:".$o_info['product_name']."-订单编号：".$oid,
			"access" => $api_access
		);
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = GD::TID_OPEN;
		$did = $o_info["api_id"];
		$log = "ptype:{$ptype}-tid:{$tid}-did:{$did}";
		try{
			$result = $transaction->cloudstorage_open($did);
			api_log($uid,$log,$result,$cloudstorage['note_appended']);
		}catch(\Exception $e){
			api_log($uid,$log,$e->getMessage(),$cloudstorage['note_appended']."-开通失败");
			$return["msg"] = "接口调用失败，请联系客服！";
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			$cloudstorage["api_bid"] = $xstr['info']["ywbh"];
			$cloudstorage["state"] = SD::SUCCESS;
			$business_id = $this->add($cloudstorage);
			if(!$business_id){
				$return["msg"] = "订单开通成功，业务生成失败！";
				$return["status"] = false;
				return $return;
			}
			$sync = $this->sync($business_id);
			// 修改订单表订单标识，业务编号
			if($sync){
				$arr = array(
					"business_id" => $business_id,
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"order_log" => $o_info."-开通成功"
				);
				if($order->order_edit($oid,$arr) !== false){
					$return["status"] = true;
					return $return;
				}else{
					$return["msg"] = "开通成功，订单表修改失败！";
					$return["bid"] = $business_id;
					$return["status"] = true;
					return $return;
				}
			}else{
				$arr = array(
					"business_id" => $business_id,
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"order_log" => $o_info."-开通成功，业务生成失败！"
				);
				$order->order_edit($oid,$arr);
				$return["msg"] = "开通成功，业务修改失败！";
				$return["bid"] = $business_id;
				$return["status"] = true;
				return $return;
			}
		}else{
			$return["msg"] = business_code($xstr['code']);
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 对象存储转正
	 * @date: 2018年11月12日10:37:39
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function onformal($m){
		$product = new ProductModel();
		$order = new OrderModel();
		$data = request();
		$uid = session("user_id");
		$id = $data['id'] + 0;
		$sync = $this->sync($id);
		// 获取订单信息
		$info = $sync["info"];
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != $uid){
			$return["msg"] = "该业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] == 3){
			$return["msg"] = "业务已过期，不可转正！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可转正！";
			$return["status"] = false;
			return $return;
		}
		if($info['free_trial'] == 0){
			$return["msg"] = "非试用业务不可转正！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$return["info"] = $info;
			$return["status"] = true;
			return $return;
		}
		// 根据产品编号获取产品信息
		$p_info = $product->get_product($info['product_id']);
		if(!$p_info){
			$return["msg"] = "产品信息获取失败！";
			$return["status"] = false;
			return $return;
		}
		$model = $data["billtype"] + 0;
		$selecttime = $data["rltime"] + 0;
		$bw = $data["dksize"] + 0;
		$bwtime = $data["dktime"] + 0;
		$neicun = $info["quota"] + 0;
		$liuliang = $info["flow"] + 0;
		if(!in_array($model,array(1,2))){
			$return["msg"] = "转正计费类型错误！";
			$return["status"] = false;
			return $return;
		}
		if(!in_array($selecttime,array(1,2,3,4,5,6,7,8,9,12,24,36))){
			$return["msg"] = "转正容量时长错误！";
			$return["status"] = false;
			return $return;
		}
		$onformal = array();
		$onformal["type"] = SD::ONFORMAL_ORDER;//购买类型计算价格
		$onformal["model"] = $model;
		$onformal["free_trial"] = 0;
		$onformal["yid"] = $selecttime;
		$onformal["quota"] = $neicun = 5;
		if($model == 1){
			$onformal["flow"] = $liuliang;
		}else{
			if($bw <= 0){
				$return["msg"] = "带宽最低1M！";
				$return["status"] = false;
				return $return;
			}
			if(!in_array($bwtime,array(1,2,3,4,5,6,7,8,9,12,24,36))){
				$return["msg"] = "转正带宽时长错误！";
				$return["status"] = false;
				return $return;
			}
			if($bwtime > $selecttime){
				$return["msg"] = "带宽时长不能超过容量时长！";
				$return["status"] = false;
				return $return;
			}
			$onformal["bandwidth"] = $bw;
			$onformal["bandTime"] = $bwtime;
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 封装订单表数据
		$order_data = array(
			"user_id" => $uid,
			"order_type" => SD::ONFORMAL_ORDER, // 转正
			"state" => SD::FAILURE_ORDER,
			"product_type" => $p_info['product_type_id'],
			"product_id" => $p_info['id'],
			"product_name" => $p_info['product_name'],
			"free_trial" => $info['free_trial'], // 不是试用
			"order_time" => $selecttime, // 续费12个月
			"order_quantity" => 1,
			"business_id" => $info['id'],
			"create_time" => current_date(),
			"area_code" => $info["area_code"], // 4001国内4002香港
			"login_name" => $info['login_name'],
			"complete_time" => current_date(),
			"system_type" => $model,
			'order_log' => '会员'.$uid."转正".$info['product_name'],
			"charge" => 0,
			"access" => $api_access
		);
		// 生成订单表
		$order_id = $order->cloudstorage_order_do_entry($order_data,$onformal);
		if($order_id <= 0){
			$return["msg"] = business_code($order_id);
			$return["status"] = false;
			return $return;
		}
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = GD::TID_POSITIVE;
		$bid = $info['api_bid'];
		$yid = $onformal["yid"];
		$model = $onformal["model"];
		$info = "ptype:{$ptype}-tid:{$tid}-bid:{$bid}-yid:{$yid}-model:{$model}";
		try{
			$result = $transaction->cloudstorag_onformal($bid,$yid,$model,$onformal);
			api_log($uid,$info,$result,$order_data['order_log']);
		}catch(\Exception $e){
			// 调用接口试用失败修改订单表
			$dataarray = array(
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log']."-接口调用失败",
				"state" => SD::FAILURE_ORDER
			); // 订单状态失败
			$order->order_edit($order_id,$dataarray);
			api_log($uid,$info,$e->getMessage(),$order_data['order_log']."-接口调用失败");
			$return["msg"] = business_code(-9);//接口调用失败
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			// 续费成功，修改业务表信息
			if($model == 1){
				$datarray = array(
					"user_id" => $uid,
					"buy_time" => $yid,
					"state" => SD::SUCCESS_ORDER,
					"free_trial" => 0,
					"model" => $model,
					'note_appended' => $info['note_appended'].'||'.current_date().'成功转正'.$yid.'个月',
					"open_time" => current_date(),
					"overdue_time" => add_dates($info["overdue_time"],$yid),
					'syqx' => $yid
				);
			}else{
				$datarray = array(
					"user_id" => $uid,
					"buy_time" => $yid,
					"state" => SD::SUCCESS_ORDER,
					"free_trial" => 0,
					"model" => $model,
					'note_appended' => $info['note_appended'].'||'.current_date().'成功转正'.$yid.'个月',
					"open_time" => current_date(),
					"overdue_time" => add_dates(current_date(),$yid),
					'syqx' => $yid,
					"dk" => $bw,
					"dk_overdue_time" => add_dates(current_date(),$bwtime),
					'dk_time' => $bwtime
				);
			}
			if($this->business_edit($id,$datarray)){
				// 业务表修改成功，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					'note_appended' => '会员'.$uid.'||'.current_date().'成功转正'.$yid.'个月',
					"order_log" => $order_data['order_log']."-转正成功"
				);
				$order->order_edit($order_id,$datarray);
				$return["status"] = true;// 转正成功
				return $return;
			}else{
				// 业务表修改失败，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"order_log" => $order_data['order_log']."-转正成功,业务表修改失败"
				);
				$order->order_edit($order_id,$datarray);
				$return["msg"] = "转正成功，业务表修改失败！";
				$return["status"] = false;
				return $return;
			}
		}else{
			$datarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log'].'-业务转正失败-接口调用错误'
			);
			$order->order_edit($order_id,$datarray);
			$return["msg"] = business_code($xstr['code']);// 转正失败
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 对象存储续费
	 * @date: 2018年11月12日10:37:39
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function renewals($m){
		$product = new ProductModel();
		$order = new OrderModel();
		$data = request();
		$uid = session("user_id");
		$id = $data['id'] + 0;
		$sync = $this->sync($id);
		// 获取订单信息
		$info = $sync["info"];
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != $uid){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1 && $info['state'] != 3){
			$return["msg"] = "业务状态错误，不可续费！";
			$return["status"] = false;
			return $return;
		}
		if($info['free_trial'] != 0){
			$return["msg"] = "试用业务不可续费！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$rl_w["product_id"] = 318;
			$rl_w["month"] = 1;
			$rl_w["type"] = 0;
			$rl_w['note_appended'] = ['eq',"cloudstorage.nc.price"];
			$price_rl = $product->get_database_price($rl_w);
			$bw_w["product_id"] = 318;
			$bw_w["month"] = 1;
			$bw_w["type"] = 0;
			$bw_w['note_appended'] = ['eq',"cloudstorage.dk.price"];
			$price_bw = $product->get_database_price($bw_w);
			$info["rl_dj"] = $price_rl["product_price"];
			$info["bw_dj"] = $price_bw["product_price"];
			$info["rl_price"] = number_format(($price_rl["product_price"] * $info["paid_quota"] * 100)/100,2,".","");
			$info["bw_price"] = number_format(($price_bw["product_price"] * $info["dk"] * 100)/100,2,".","");
			$return["info"] = $info;
			$return["status"] = true;
			return $return;
		}
		// 根据产品编号获取产品信息
		$p_info = $product->get_product($info['product_id']);
		if(!$p_info){
			$return["msg"] = "产品信息获取失败！";
			$return["status"] = false;
			return $return;
		}
		$syqx = $info["syqx"];
		$dk_time = $info["dk_time"];
		$yid = $data["yid"] + 0;
		$type = $data["type"] + 0;
		$renewals["yid"] = $yid;
		$renewals["quota"] = $info["paid_quota"];
		$renewals["dk"] = $info["dk"];
		$renewals["model"] = $type;
		$renewals["type"] = SD::RENEWALS_ORDER;
		if(!in_array($yid,array(1,2,3,4,5,6,7,8,9,12,24,36))){
			$return["msg"] = "续费时长错误！";
			$return["status"] = false;
			return $return;
		}
		if(!in_array($type,array(1,2,3))){
			$return["msg"] = "续费类型错误！";
			$return["status"] = false;
			return $return;
		}
		if($type != 1 && $info["model"] == 1){
			$return["msg"] = "流量模式不能续费带宽！";
			$return["status"] = false;
			return $return;
		}
		if($type == 2){
			if($syqx < ($yid + $dk_time)){
				$return["msg"] = "带宽时长不能超过容量时长！";
				$return["status"] = false;
				return $return;
			}
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 封装订单表数据
		$order_data = array(
			"user_id" => $uid,
			"order_type" => SD::RENEWALS_ORDER, // 续费
			"state" => SD::FAILURE_ORDER,
			"product_type" => $p_info['product_type_id'],
			"product_id" => $p_info['id'],
			"product_name" => $p_info['product_name'],
			"free_trial" => $info['free_trial'], // 不是试用
			"order_time" => $yid, // 续费12个月
			"order_quantity" => 1,
			"business_id" => $info['id'],
			"create_time" => current_date(),
			"area_code" => $info["area_code"], // 4001国内4002香港
			"login_name" => $info['login_name'],
			"complete_time" => current_date(),
			"system_type" => $type,
			'order_log' => '会员'.$uid."续费".$info['product_name'],
			"charge" => 0,
			"access" => $api_access
		);
		// 生成订单表
		$order_id = $order->cloudstorage_order_do_entry($order_data,$renewals);
		if($order_id <= 0){
			$return["msg"] = business_code($order_id);
			$return["status"] = false;
			return $return;
		}
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = GD::TID_RENEWALS;
		$bid = $info['api_bid'];
		$info = "ptype:{$ptype}-tid:{$tid}-bid:{$bid}-yid:{$yid}-type:{$type}";
		try{
			$result = $transaction->cloudstorage_renewals($bid,$yid,$type);
			api_log($uid,$info,$result,$order_data['order_log']);
		}catch(\Exception $e){
			// 调用接口试用失败修改订单表
			$dataarray = array(
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log']."-接口调用失败",
				"state" => SD::FAILURE_ORDER
			); // 订单状态失败
			$order->order_edit($order_id,$dataarray);
			api_log($uid,$info,$e->getMessage(),$order_data['order_log']."-接口调用失败");
			$return["msg"] = business_code(-9);//接口调用失败
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			// 续费成功，修改业务表信息
			if($type == 1){
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					'note_appended' => $info['note_appended'].'||'.current_date().'成功续费'.$yid.'个月',
					"overdue_time" => add_dates($info["overdue_time"],$yid),
					'syqx' => $info ['syqx'] + $yid
				);
			}elseif($type == 2){
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					'note_appended' => $info['note_appended'].'||'.current_date().'成功续费'.$yid.'个月',
					"dk_overdue_time" => add_dates($info["overdue_time"],$yid),
					'dk_time' => $info ['syqx'] + $yid
				);
			}else{
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					'note_appended' => $info['note_appended'].'||'.current_date().'成功续费'.$yid.'个月',
					"overdue_time" => add_dates($info["overdue_time"],$yid),
					'syqx' => $info ['syqx'] + $yid,
					"dk_overdue_time" => add_dates($info["overdue_time"],$yid),
					'dk_time' => $info ['syqx'] + $yid
				);
			}
			if($this->business_edit($id,$datarray)){
				// 业务表修改成功，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					'note_appended' => '会员'.$uid.'||'.current_date().'成功续费'.$yid.'个月',
					"order_log" => $order_data['order_log']."-续费成功"
				);
				$order->order_edit($order_id,$datarray);
				$return["status"] = true;// 续费成功
				return $return;
			}else{
				// 业务表修改失败，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"order_log" => $order_data['order_log']."-续费成功,业务表修改失败"
				);
				$order->order_edit($order_id,$datarray);
				$return["msg"] = business_code(-102);// 续费成功，业务表修改失败
				$return["status"] = false;
				return $return;
			}
		}else{
			$datarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log'].'-业务续费失败-接口调用错误'
			);
			$order->order_edit($order_id,$datarray);
			$return["msg"] = business_code($xstr['code']);// 续费失败
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 快云存储增值
	 * @date: 2018年11月12日16:52:03
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function appreciation($m){
		$product = new ProductModel();
		$order = new OrderModel();
		$data = request();
		$uid = session("user_id");
		$id = $data['id'] + 0;
		$sync = $this->sync($id);
		// 获取订单信息
		$info = $sync["info"];
		if(!$info){
			$return["msg"] = "业务不存在或不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] == 3){
			$return["msg"] = "您的业务已经到期，暂不能增值，请先续费！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可增值！";
			$return["status"] = false;
			return $return;
		}
		if($info['free_trial'] != 0){
			$return["msg"] = "试用业务不可增值！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$p_w["product_id"] = 318;
			$p_w["type"] = 0;
			$p_w['state'] = ['eq','1'];
			$price_p = M('product_price')->where($p_w)->select();
			$price_rl = $price_bw = 0;
			$ll_dj = array();
			foreach($price_p as $pval){
				if($pval["note_appended"] == "cloudstorage.nc.price"){
					$price_rl = $pval["product_price"];
				}
				if($pval["note_appended"] == "cloudstorage.dk.price"){
					$price_bw = $pval["product_price"];
				}
				if($pval["note_appended"] == "cloudstorage.ll.price"){
					$ll_dj[$pval["month"]] = $pval["product_price"];
				}
			}
			$info["rl_dj"] = $price_rl;
			$info["bw_dj"] = $price_bw;
			$ll_dj = json_encode($ll_dj);
			$info["ll_dj"] = $ll_dj;
			$return["info"] = $info;
			$return["status"] = true;
			return $return;
		}
		// 根据产品编号获取产品信息
		$p_info = $product->get_product($info['product_id']);
		if(!$p_info){
			$return["msg"] = "产品信息获取失败！";
			$return["status"] = false;
			return $return;
		}
		$rl_paid = $info["paid_quota"] + 0;
		$dk = $info["dk"] + 0;
		$dk_time = $info["dk_time"] + 0;
		$syqx = $info["syqx"] + 0;
		$yid = $data["yid"] + 0;
		$size = $data["size"] + 0;
		$model = $data["model"] + 0;
		$app["yid"] = $yid;
		$app["size"] = $size;
		$app["model"] = $model;
		$app["type"] = 3;//计算价格类型3 增值
		if(!in_array($model,array(1,2,3))){
			$return["msg"] = "增值类型错误！";
			$return["status"] = false;
			return $return;
		}
		if($size < 1){
			$return["msg"] = "增值大小错误！";
			$return["status"] = false;
			return $return;
		}
		if($model == 1){
			$app_type = "增值容量";
			$unit = "GB";
			if($rl_paid > 0){//是否增值过容量
				$yid = $syqx;
			}
		}elseif($model == 3){
			$app_type = "增值流量";
			$unit = "GB";
			$yid = $syqx;
		}else{
			$app_type = "增值带宽";
			$unit = "M";
			if($info["dk_dqzt"] == 1){//带宽是否到期
				$return["msg"] = "您的带宽业务已经到期，暂不能增值，请先续费！";
				$return["status"] = false;
				return $return;
			}
			if($dk > 0){//带宽未到期且带宽大于0，说明有带宽业务
				$yid = $dk_time;
			}else{
				if($syqx < ($yid + $dk_time)){//增值后的带宽剩余时长不能大于业务剩余时长
					$return["msg"] = "带宽时长不能超过业务到期时长！";
					$return["status"] = false;
					return $return;
				}
			}
		}
		if($yid < 1 || $yid > 36){
			$return["msg"] = "增值时长错误！";
			$return["status"] = false;
			return $return;
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 封装订单表数据
		$order_data = array(
			"user_id" => $uid,
			"order_type" => SD::APP_ORDER, // 增值
			"state" => SD::FAILURE_ORDER,
			"product_type" => $p_info['product_type_id'],
			"product_id" => $p_info['id'],
			"product_name" => $p_info['product_name'],
			"free_trial" => $info['free_trial'], // 不是试用
			"order_time" => $yid, // 增值12个月
			"order_quantity" => 1,
			"business_id" => $info['id'],
			"create_time" => current_date(),
			"area_code" => $info["area_code"], // 4001国内4002香港
			"login_name" => $info['login_name'],
			"complete_time" => current_date(),
			"system_type" => $model,
			'order_log' => "会员:{$uid}-{$info['product_name']}-增值{$app_type}:{$size}{$unit}-时长:{$yid}个月",
			"charge" => 0,
			"access" => $api_access
		);
		// 生成订单表
		$order_id = $order->cloudstorage_order_do_entry($order_data,$app);
		if($order_id <= 0){
			$return["msg"] = business_code($order_id);
			$return["status"] = false;
			return $return;
		}
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = GD::TID_APPRECIATION;
		$bid = $info['api_bid'];
		$info = "ptype:{$ptype}-tid:{$tid}-bid:{$bid}-yid:{$yid}-side:{$size}-type:{$model}";
		try{
			$result = $transaction->cloudstorage_apperciation($bid,$yid,$size,$model);
			api_log($uid,$info,$result,$order_data['order_log']);
		}catch(\Exception $e){
			// 调用接口试用失败修改订单表
			$dataarray = array(
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log']."-接口调用失败",
				"state" => SD::FAILURE_ORDER
			); // 订单状态失败
			$order->order_edit($order_id,$dataarray);
			api_log($uid,$info,$e->getMessage(),$order_data['order_log']."-接口调用失败");
			$return["msg"] = business_code(-9);//接口调用失败
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			// 续费成功，修改业务表信息
			if($model == 1){
				if($rl_paid > 0){//是否增值过容量
					$datarray = array(
						"state" => SD::SUCCESS_ORDER,
						'note_appended' => $info['note_appended'].'||'.current_date()."-成功{$app_type}:{$size}{$unit}-时长:{$yid}个月",
						'quota' => $size + $info["quota"],
						'paid_quota' => $size + $info["quota"]
					);
				}else{
					$datarray = array(
						"state" => SD::SUCCESS_ORDER,
						'note_appended' => $info['note_appended'].'||'.current_date()."-成功{$app_type}:{$size}{$unit}-时长:{$yid}个月",
						"overdue_time" => add_dates(current_date(),$yid),
						'syqx' => $yid,
						'quota' => $size,
						'paid_quota' => $size
					);
				}
			}elseif($model == 3){
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					'note_appended' => $info['note_appended'].'||'.current_date()."-成功{$app_type}:{$size}{$unit}",
					'flow' => $size,
					'paid_flow' => $size
				);
			}else{
				if($dk > 0){//带宽未到期且带宽大于0，说明有带宽业务
					$datarray = array(
						"state" => SD::SUCCESS_ORDER,
						'note_appended' => $info['note_appended'].'||'.current_date()."-成功{$app_type}:{$size}{$unit}-时长:{$yid}个月",
						'dk' => $info['dk'] + $size,
					);
				}else{
					$datarray = array(
						"state" => SD::SUCCESS_ORDER,
						'note_appended' => $info['note_appended'].'||'.current_date()."-成功{$app_type}:{$size}{$unit}-时长:{$yid}个月",
						"overdue_time" => add_dates($info["overdue_time"],$yid),
						'dk' => $size,
						"dk_overdue_time" => add_dates(current_date(),$yid),
						'dk_time' => $info['dk_time'] + $yid
					);
				}
			}
			if($this->business_edit($id,$datarray)){
				// 业务表修改成功，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					'note_appended' => '会员'.$uid.'||'.current_date()."-成功{$app_type}:{$size}{$unit}",
					"order_log" => $order_data['order_log']."-增值成功"
				);
				$order->order_edit($order_id,$datarray);
				$return["status"] = true;// 增值成功
				return $return;
			}else{
				// 业务表修改失败，修改订单表
				$datarray = array(
					"state" => SD::SUCCESS_ORDER,
					"complete_time" => current_date(),
					"order_log" => $order_data['order_log']."-增值成功,业务表修改失败"
				);
				$order->order_edit($order_id,$datarray);
				$return["msg"] = business_code(-102);// 续费成功，业务表修改失败
				$return["status"] = false;
				return $return;
			}
		}else{
			$datarray = array(
				"state" => SD::FAILURE_ORDER, // 订单状态失败
				"complete_time" => current_date(),
				"order_log" => $order_data['order_log'].'-业务增值失败-接口调用错误'
			);
			$order->order_edit($order_id,$datarray);
			$return["msg"] = business_code($xstr['code']);// 续费失败
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 同步业务信息
	 * @author: Guopeng
	 * @date: 2018年11月12日10:37:39
	 * @param: $yw_id
	 * @return boolean
	 */
	public function sync($id){
		$info = $this->where(array("id"=>$id))->find();
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != session("user_id")){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		$yw_id = $info["api_bid"];
		$return["info"] = $info;
		$storage_respository = new \Common\Respository\CloudstorageBusinessRespository($this);
		$result = $storage_respository->CloudstorageBusinessSynchronizing($yw_id);
		if($result === false){
			$return["msg"] = $storage_respository->model()->getError();
		}
		$return["status"] = $result;
		return $return;
	}

	/**
	 * 设置快云存储空间属性
	 * @date: 2018年11月23日16:03:58
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function setauth($m){
		$data = request();
		$uid = session("user_id");
		$id = $data['yid'] + 0;
		$info = $this->where(array("id"=>$id))->find();
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != session("user_id")){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可管理！";
			$return["status"] = false;
			return $return;
		}
		$space_id = $data['sid'] + 0;
		$space_w["id"] = $space_id;
		$space_w["yid"] = $id;
		$space_info = M("cloudstorage_space")->where($space_w)->find();
		if(!$space_info){
			$return["msg"] = "该空间不存在！";
			$return["status"] = false;
			return $return;
		}
		if($space_info["user_id"] != session("user_id")){
			$return["msg"] = "空间不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$assign["yid"] = $id;
			$assign["sid"] = $space_id;
			$assign["space"] = $space_info["space"];
			$assign["acl"] = $space_info["quanxian"];
			$return["info"] = $assign;
			$return["status"] = true;
			return $return;
		}
		$acl = $data["acl"] + 0;
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$pname = "storagebucketacl";
		$tid = 74;
		$bid = $info['api_bid'];
		$bucketName = $space_info["space"];
		$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}-acl:{$acl}";
		try{
			$result = $transaction->cloudstorage_bucket_acl($bid,$bucketName,$acl);
			api_log($uid,$info,$result,"设置快云存储空间属性");
		}catch(\Exception $e){
			api_log($uid,$info,$e->getMessage(),"设置快云存储空间属性-接口调用失败");
			$return["msg"] = business_code(-9);//接口调用失败
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			$res = M("cloudstorage_space")->where($space_w)->save(array("quanxian"=>$acl));
			$return["status"] = true;// 设置快云存储空间属性成功
			return $return;
		}else{
			$return["msg"] = business_code($xstr['code']);// 设置快云存储空间属性失败
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 域名管理
	 * @date: 2018年11月23日16:03:58
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function setdomain($m){
		$data = request();
		$uid = session("user_id");
		$yid = $data['yid'] + 0;
		$info = $this->where(array("id"=>$yid))->find();
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != session("user_id")){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可管理！";
			$return["status"] = false;
			return $return;
		}
		$space_id = $data['sid'] + 0;
		$space_w["id"] = $space_id;
		$space_w["yid"] = $yid;
		$space_info = M("cloudstorage_space")->where($space_w)->find();
		if(!$space_info){
			$return["msg"] = "该空间不存在！";
			$return["status"] = false;
			return $return;
		}
		if($space_info["user_id"] != session("user_id")){
			$return["msg"] = "空间不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		$space_domain_w["sid"] = $space_id;
		$space_domain_w["yid"] = $yid;
		$space_domain_info = M("cloudstorage_space_domain")->where($space_domain_w)->select();
		if($m){
			$assign["yid"] = $yid;
			$assign["sid"] = $space_id;
			$assign["space"] = $space_info["space"];
			$assign["space_domain_info"] = $space_domain_info;
			$return["info"] = $assign;
			$return["status"] = true;
			return $return;
		}
		$type = $data['type'];
		if($type == "add"){
			$domain = trim($data['domain']);
			$regex = "/^([a-zA-z0-9\x{4e00}-\x{9fa5}-]+\.)+([a-zA-z\x{4e00}-\x{9fa5}]+)$/u";
			if(!preg_match($regex,$domain) || $domain == ""){
				$return["msg"] = "域名不规范，请重新输入！";
				$return["status"] = false;
				return $return;
			}
			foreach($space_domain_info as $value){
				if($domain == $value["domain"]){
					$return["msg"] = "该域名已绑定！";
					$return["status"] = false;
					return $return;
				}
			}
		}elseif($type == "delete"){
			$id = $data['id'] + 0;
			$is_set = false;
			foreach($space_domain_info as $value){
				if($id == $value["id"]){
					$is_set = true;
					$domain_info = $value;
				}
			}
			if(!$is_set){
				$return["msg"] = "该域名不存在！";
				$return["status"] = false;
				return $return;
			}
			$domain = $domain_info["domain"];
		}else{
			$return["msg"] = "操作类型错误！";
			$return["status"] = false;
			return $return;
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = 74;
		$bid = $info['api_bid'];
		$bucketName = $space_info["space"];
		$type = $data["type"];
		if($type == "delete"){
			$pname = "storagebucketacl";
			$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}-domain:{$domain}";
			try{
				$result = $transaction->cloudstorage_domain_remove($bid,$bucketName,$domain);
				api_log($uid,$info,$result,"删除快云存储空间绑定域名");
			}catch(\Exception $e){
				api_log($uid,$info,$e->getMessage(),"删除快云存储空间绑定域名-接口调用失败");
				$return["msg"] = business_code(-9);//接口调用失败
				$return["status"] = false;
				return $return;
			}
			$xstr = json_decode($result,true);
			$res = M("cloudstorage_space_domain")->where(array("id"=>$id))->delete();
			$return["msg"] = "删除空间绑定域名成功！";
			$return["status"] = true;// 删除快云存储空间绑定域名成功
			return $return;
		}elseif($type == "add"){
			$pname = "storagedomainbind";
			$type = 0;//是否上传SSL证书支持HTTPS访问：0否，1是
			$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}-domain:{$domain}-type:{$type}";
			try{
				$result = $transaction->cloudstorage_domain_bind($bid,$bucketName,$domain,$type);
				api_log($uid,$info,$result,"添加快云存储空间绑定域名");
			}catch(\Exception $e){
				api_log($uid,$info,$e->getMessage(),"添加快云存储空间绑定域名-接口调用失败");
				$return["msg"] = business_code(-9);//接口调用失败
				$return["status"] = false;
				return $return;
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] == 0 && $xstr['code'] !== null){
				$data_arr = array(
					"user_id" => $uid,
					"yid" => $yid,
					"sid" => $space_id,
					"domain" => $domain,
					"state" => 1,
					"is_ssl" => $type,
					"createtime" => current_date(),
					"updatetime" => current_date()
				);
				$res = M("cloudstorage_space_domain")->add($data_arr);
				$return["msg"] = "添加空间绑定域名成功！";
				$return["status"] = true;// 添加快云存储空间绑定域名成功
				return $return;
			}else{
				$data_arr = array(
                                                                                                                                                                                                                                                                                                                                                                                                                                   					"yid" => $yid,
					"sid" => $space_id,
					"domain" => $domain,
					"state" => 2,
					"is_ssl" => $type,
					"createtime" => current_date(),
					"updatetime" => current_date()
				);
				$res = M("cloudstorage_space_domain")->add($data_arr);
				$return["msg"] = business_code($xstr['code']);// 添加快云存储空间绑定域名失败
				$return["status"] = false;
				return $return;
			}
		}else{
			$return["msg"] = "操作类型错误！";
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 防盗链管理
	 * @date: 2018年11月27日09:41:13
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function setlinkdef($m){
		$data = request();
		$uid = session("user_id");
		$id = $data['yid'] + 0;
		$info = $this->where(array("id"=>$id))->find();
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != session("user_id")){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可管理！";
			$return["status"] = false;
			return $return;
		}
		$space_id = $data['sid'] + 0;
		$space_w["id"] = $space_id;
		$space_w["yid"] = $id;
		$space_info = M("cloudstorage_space")->where($space_w)->find();
		if(!$space_info){
			$return["msg"] = "该空间不存在！";
			$return["status"] = false;
			return $return;
		}
		if($space_info["user_id"] != session("user_id")){
			$return["msg"] = "空间不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$assign["yid"] = $id;
			$assign["sid"] = $space_id;
			$assign["space"] = $space_info["space"];
			$assign["refer"] = strtr($space_info["refer"],",","\r\n");
			$return["info"] = $assign;
			$return["status"] = true;
			return $return;
		}
		$refer = $data["refer"];
		if($refer){
			$refer_arr = explode(",",$refer);
			$regex = "/^(?:[a-z0-9\x{4e00}-\x{9fa5}\-?]+|\*)(?:\.[a-z0-9\x{4e00}-\x{9fa5}\-?]+)*\.(?:[a-z]{2,4}|中国|公司|网络)$/u";
			//遍历输入的域名，判断是否有相同的
			for($i = 0;$i < count($refer_arr) - 1;$i++){
				if(!preg_match($regex,trim($refer_arr[$i])) || trim($refer_arr[$i]) == ""){
					$return["msg"] = "域名不规范，请重新输入！";
					$return["status"] = false;
					return $return;
				}
				for($j = $i + 1;$j < count($refer_arr);$j++){
					if($refer_arr[$i] == $refer_arr[$j]){
						$return["msg"] = "域名有重复，请重新输入！";
						$return["status"] = false;
						return $return;
					}
				}
			}
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = 74;
		$bid = $info['api_bid'];
		$bucketName = $space_info["space"];
		$pname = "storagelinkdef";
		$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}-refer:{$refer}";
		try{
			$result = $transaction->cloudstorage_linkdef($bid,$bucketName,$refer);
			api_log($uid,$info,$result,"设置快云存储空间防盗链");
		}catch(\Exception $e){
			api_log($uid,$info,$e->getMessage(),"设置快云存储空间防盗链-接口调用失败");
			$return["msg"] = business_code(-9);//接口调用失败
			$return["status"] = false;
			return $return;
		}
		$xstr = json_decode($result,true);
		if($xstr['code'] == 0 && $xstr['code'] !== null){
			$res = M("cloudstorage_space")->where($space_w)->save(array("refer"=>$refer));
			$return["msg"] = "设置快云存储空间防盗链！";
			$return["status"] = true;// 设置快云存储空间防盗链成功
			return $return;
		}else{
			$return["msg"] = business_code($xstr['code']);// 设置快云存储空间防盗链失败
			$return["status"] = false;
			return $return;
		}
	}

	/**
	 * 设置镜像存储
	 * @date: 2018年11月27日15:51:37
	 * @author: Guopeng
	 * @param bool $m true：获取信息，false：操作
	 * @return bool
	 */
	public function setmirror($m){
		$data = request();
		$uid = session("user_id");
		$id = $data['yid'] + 0;
		$info = $this->where(array("id"=>$id))->find();
		if(!$info){
			$return["msg"] = "该业务不存在！";
			$return["status"] = false;
			return $return;
		}
		if($info["user_id"] != session("user_id")){
			$return["msg"] = "业务不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($info['state'] != 1){
			$return["msg"] = "业务状态错误，不可管理！";
			$return["status"] = false;
			return $return;
		}
		$space_id = $data['sid'] + 0;
		$space_w["id"] = $space_id;
		$space_w["yid"] = $id;
		$space_info = M("cloudstorage_space")->where($space_w)->find();
		if(!$space_info){
			$return["msg"] = "该空间不存在！";
			$return["status"] = false;
			return $return;
		}
		if($space_info["user_id"] != session("user_id")){
			$return["msg"] = "空间不属于该会员！";
			$return["status"] = false;
			return $return;
		}
		if($m){
			$assign["yid"] = $id;
			$assign["sid"] = $space_id;
			$assign["space"] = $space_info["space"];
			$assign["mirror"] = $space_info["mirror"];
			$return["info"] = $assign;
			$return["status"] = true;
			return $return;
		}
		$model = $data["model"];
		if($model == 1){
			$bdUrl = trim($data["bdUrl"]);
			$name = rtrim(trim($data["name"]),",");
			if($name != ""){
				foreach(explode(",",$name) as $val){
					if(!in_array($val,array(1,2,3))){
						$return["msg"] = "搜索引擎抓取方式选取错误！";
						$return["status"] = false;
						return $return;
					}
				}
			}
			/*验证镜像源地址提交格式*/
			/*$regex = "/^(?:(?:https?|http)://)/g";
			if(!preg_match($regex,$bdUrl) || $bdUrl == ""){
				$return["msg"] = "镜像源地址不规范，请重新输入！";
				$return["status"] = false;
				return $return;
			}*/
		}elseif($model == 2){
		}else{
			$return["msg"] = "参数错误！";
			$return["status"] = false;
			return $return;
		}
		$api_access = $info["access"] + 0;
		$api_access = $api_access ? $api_access : 1;
		// 调用zzidc接口
		$agent = new AgentAide(1,$api_access);
		$transaction = $agent->servant;
		//传参
		$ptype = GD::PTYPE_CLOUD_STORAGE;
		$tid = 74;
		$bid = $info['api_bid'];
		$bucketName = $space_info["space"];
		if($model == 1){
			$type = $name;
			$refer = $bdUrl;
			$pname = "storagemirror";
			$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}-refer:{$refer}-type:{$type}";
			try{
				$result = $transaction->cloudstorage_mirror($bid,$bucketName,$refer,$type);
				api_log($uid,$info,$result,"设置镜像存储");
			}catch(\Exception $e){
				api_log($uid,$info,$e->getMessage(),"设置镜像存储-接口调用失败");
				$return["msg"] = business_code(-9);//接口调用失败
				$return["status"] = false;
				return $return;
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] == 0 && $xstr['code'] !== null){
				$res = M("cloudstorage_space")->where($space_w)->save(array("mirror"=>$refer));
				$return["msg"] = "设置镜像存储！";
				$return["status"] = true;// 设置镜像存储成功
				return $return;
			}else{
				$return["msg"] = business_code($xstr['code']);// 设置镜像存储失败
				$return["status"] = false;
				return $return;
			}
		}elseif($model == 2){
			$pname = "storagemirrordel";
			$info = "ptype:{$ptype}-pname:{$pname}-tid:{$tid}-bid:{$bid}-bucketName:{$bucketName}";
			try{
				$result = $transaction->cloudstorage_mirrordel($bid,$bucketName);
				api_log($uid,$info,$result,"删除镜像存储");
			}catch(\Exception $e){
				api_log($uid,$info,$e->getMessage(),"删除镜像存储-接口调用失败");
				$return["msg"] = business_code(-9);//接口调用失败
				$return["status"] = false;
				return $return;
			}
			$xstr = json_decode($result,true);
			if($xstr['code'] == 0 && $xstr['code'] !== null){
				$res = M("cloudstorage_space")->where($space_w)->save(array("mirror"=>""));
				$return["msg"] = "删除镜像存储！";
				$return["status"] = true;// 删除镜像存储成功
				return $return;
			}else{
				$return["msg"] = business_code($xstr['code']);// 删除镜像存储失败
				$return["status"] = false;
				return $return;
			}
		}
	}
	/****************************************************************************/

	/**
	 * 自动组装查询条件
	 * @date: 2018年11月12日16:52:03
	 * @author: Guopeng
	 */
	public function conver_par(){
		$date = request();
		$where["bs.user_id"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$select = clearXSS($date['select']);
			$map['bs.api_bid'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['bs.ywbs'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map["bs.beizhu"] = array("like","%$select%");
			$where['_complex'] = $map;
		}
		return $where;
	}
	/**根据业务ID，获取用户存储key值,业务信息  access_key  secret_key
	 * gcf 2018-11-06
	 *
	*/
	public function getuserkey($yid){
	//	return $this->where(['id'=>$yid,'ywbs'=>$ywbs])->field('access_key,secret_key,create_time,access')->find();
		return $this->where(['id'=>$yid])->field('*')->find();
	}
	/**
	 * 获取存储使用量
	 * gcf
	 */
	public function get_storage_use($access_key,$secret_key,$yid){
		//获取存储使用量接口参数
		$use['accessKey']=$access_key;
		$use['secretKey']=$secret_key;
		$info="accessKey:".$access_key."—secretKey:".$secret_key;

		$path="restful/storageapi/bucket/getUsedQuota";//获取用户已用空间大小/总空间大小
		$getparams="";
		try{
			$result = jiekou_storage($use,$path,1,$getparams);
			api_log(session("user_id"),$info,$result,"【云存储】获取存储使用量，业务编号：[".$yid."]");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】获取存储使用量，业务编号：[".$yid."]");
		}
		/*输出接口结果***********/
		//  var_dump($result);exit;

		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,接口调用成功，根据返回信息，*/
			return ['code'=>-1,'msg'=>$xstr["message"]];
		}else{  //调用失败，返回错误信息
			return ['code'=>-2,'msg'=>$xstr["message"]];
		}

	}



}