<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2017/1/10
 * Time: 16:22
 */

namespace Frontend\Model;

use Common\Data\StateData as SD;
use Frontend\Model\BusinessModel;
use Frontend\Model\CloudstorageModel;
use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;

/**
 * 对象存储空间
 * @date: 2018年11月1日
 * @author: gcf
 */
class CloudstoragespaceModel extends BusinessModel{

	protected $trueTableName = 'agent_cloudstorage_space';
	/**
	 * 2018-11-01
	 * gcf
	 * $where条件
	 * */
	public function conver_par(){
		$date = request();
		$where["user_id"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$select = clearXSS($date['select']);
			$map['api_bid'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['nw_ip'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map["beizhu"] = array("like","%$select%");
			$where['_complex'] = $map;
		}
		return $where;
	}


	/**
	 * 获取对象存储空间列表
	 * @date: 2018年11月01日
	 * @author: gcf
	 * @param $where
	 * @param $page
	 * @param string $order
	 * @return array|bool
	 */
	public function get_cloudstorage_space_list($where,$per_page = 5,$order,$fields="*"){
		if(empty($order_by)){
			$order = 'DESC';
		}
		$info = [];
		if($where){
			$sum = $this->paging($where,$per_page,$fields,$order);
			$data = $this->queryBuilder($where,$fields,$order)
				->limit($sum['page']->firstRow.','.$sum['page']->listRows)->select();
			$info['count'] = $sum['count'];
			$info['show'] = $sum['page']->show();
			//对自带thinkphp分页进行替换
			$show = str_replace("<div>","",$info["show"]);
			$show = str_replace("</div>","",$show);
			$show = str_replace("span","a",$show);
			$info['page_show'] = $show;
			$info['list'] = $data;
			return $info;
		}else{
			$this->error = "查询条件为空";
			return false;
		}
	}
	/**
	 *  分页
	 * @date: 2018年11月2日
	 * @author: gcf
	 */
	public function paging($where,$per_page = 5,$fields,$order){
		$sumpage = [];
		$count = $this->queryBuilder($where,$fields,$order)->count();
		$Page = new \Think\Page($count,$per_page);// 实例化分页类 传入总记录数和每页显示的记录数
		$Page->setConfig('prev','上一页');
		$Page->setConfig('next','下一页');
		$Page->setConfig("first","首页");
		$Page->setConfig("last","尾页");
		$date = request();
		//分页跳转的时候保证查询条件
		foreach($date as $key => $val){
			$Page->parameter[$key] = urlencode($val);
		}
		$sumpage['page'] = $Page;
		$sumpage['count'] = $count;
		return $sumpage;
	}

	/**
	 * 获取带条件的总记录数
	 * @date: 2018年11月1日
	 * @author: gcf
	 */
	public function queryBuilder($where,$field="",$order_by = "DESC"){
		return $this->field($field)->where($where)->order("createtime ".$order_by);//返回带条件的总记录数;
	}
	/**判断快云存储空间是否存在
	 * 参数：业务id，业务标识，空间名称
	 * gcf  2018-11-8
	*/
	public function spaceisexist($yid,$spaceName){

		//先获取用户key值
		$cloudstorage= new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);//获取业务信息
		 if(!$cloudstoragebs['id']){
			return "业务信息错误！";
		}
		//调用空间名称是否存在接口参数。。。。
		$isexist['bucketName']=$spaceName;
		$isexist['accessKey']=$cloudstoragebs['access_key'];
		$isexist['secretKey']=$cloudstoragebs['secret_key'];

		$info="bucketName:".$spaceName."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key'];

		$path="restful/storageapi/bucket/isBucketExit";//判断快云存储空间是否存在接口地址
		try{
			$result = jiekou_storage($isexist,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】验证存储空间[".$spaceName."]是否存在，业务编号：[".$yid.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】验证存储空间[".$spaceName."]是否存在，业务编号：[".$yid.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,空间名是否存在接口调用成功，根据返回信息，存在则直接返回提示已存在，不存在就进行创建空间接口调用*/
			if($xstr['message']=="true"){ //空间名字已存在
				return 1;
			}else{ //空间名不存在，可创建
				return -1;
			}
		}else{  //空间名是否存在接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}
	/**
	 * 创建空间
	 * 参数：业务id，业务标识，空间名称，权限
	 * gcf 2018-11-09
	*/

	public function createspace($yid,$bucketName,$acl){
		//获取用户key值
		$cloudstorage= new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);//获取业务信息
		if(!$cloudstoragebs['id']){
			return "业务信息错误！";
		}
		//验证空间名是否存在
		$resspace=$this->where(['yid'=>$yid,'space'=>$bucketName])->find();
		if($resspace['id']){
			return "空间名称被占用！";
		}

		//调用创建空间接口参数。。。。
		$create['bucketName']=$bucketName;
		$create['accessKey']=$cloudstoragebs['access_key'];
		$create['secretKey']=$cloudstoragebs['secret_key'];
		$create['acl']=$acl;
		$info="bucketName:".$bucketName."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—acl:".$acl;

		$path="restful/storageapi/bucket/createBucket";//创建存储空间接口地址
		try{
			$result = jiekou_storage($create,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】创建存储空间[".$bucketName."]，业务编号：[".$yid.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】创建存储空间[".$bucketName."]，业务编号：[".$yid.']');
		}
		// var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,创建空间接口调用成功，根据返回信息，*/
				return -1;
		}else{  //创建空间接口调用失败，返回错误信息
			return $xstr["message"];
		}

	}
	/**
	 * 获取空间信息
	 * gcf 2018-11-09
	 */
	public function getspaceinfo($space_id){
		return $this->where(['id'=>$space_id])->find();
	}
	/**
	 * 删除空间
	 * gcf 2018-11-09
	 */
	public function delspace($spaceinfo){

		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($spaceinfo['yid']);

		if($cloudstoragebs['user_id']!=session('user_id')){
			return "此业务不属于当前会员！请合理操作！";
		}

		//删除空间接口参数。。。。
		$del['bucketName']=$spaceinfo['space'];
		$del['accessKey']=$cloudstoragebs['access_key'];
		$del['secretKey']=$cloudstoragebs['secret_key'];

		$info="bucketName:".$spaceinfo['space']."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key'];

		$path="restful/storageapi/bucket/deleteBucket";//删除存储空间接口地址
		try{
			$result = jiekou_storage($del,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】删除存储空间[".$spaceinfo['space']."]，业务编号：[".$cloudstoragebs['id'].']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】删除存储空间[".$spaceinfo['space']."]，业务编号：[".$cloudstoragebs['id'].']');
		}
		/*输出接口结果***********/
		//   var_dump($message);exit;

		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,删除空间成功，根据返回信息，*/
				return -1;
		}else{  //删除空间失败，返回错误信息
			return $xstr["message"];
		}
	}

	/**
	 * 同步空间列表
	 * gcf 2018-11-12
	 */
	public function getallspaces($cloudstoragebs){

		$spaces['accessKey']=$cloudstoragebs['access_key'];
		$spaces['secretKey']=$cloudstoragebs['secret_key'];

		$info="accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key'];

		$path="restful/storageapi/bucket/bucketList";//获取所有空间接口地址
		$getparams="&accessKey=".$spaces['accessKey']."&secretKey=".$spaces['secretKey'];
		try{
			$result = jiekou_storage($spaces,$path,2,$getparams);
			api_log(session("user_id"),$info,$result,"【云存储】同步空间，业务编号：[".$cloudstoragebs['id']."]");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】同步空间，业务编号：[".$cloudstoragebs['id']."]");
		}
		/*输出接口结果***********/
		//  var_dump($result);exit;

		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,获取所有空间接口调用成功，根据返回信息，*/
			return ['code'=>-1,'msg'=>$xstr["message"]];
		}else{  //创建空间接口调用失败，返回错误信息
			return ['code'=>-2,'msg'=>$xstr["message"]];
		}

	}
	/**
	 * 获取空间使用容量
	 * gcf
	 */
	public function get_rl_use($access_key,$secret_key,$yid,$space){
		$rong['accessKey']=$access_key;
		$rong['secretKey']=$secret_key;
		$rong['bucketName']=$space;
		$info="accessKey:".$access_key."—secretKey:".$secret_key."—bucketName:".$space;
		$path="restful/storageapi/bucket/getBucketQuotaUsage";//获取所有空间接口地址
		$getparams="";
		try{
			$result = jiekou_storage($rong,$path,1,$getparams);
			api_log(session("user_id"),$info,$result,"【云存储】获取空间使用容量，空间：[".$space."]业务编号：[".$yid."]");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】获取空间使用容量，空间：[".$space."]业务编号：[".$yid."]");
		}
		/*输出接口结果***********/
		//  var_dump($result);exit;

		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,接口调用成功，根据返回信息，*/
			return $xstr["message"];
		}else{  //接口调用失败，返回错误信息
			return "--";
		}


}
	/****************************************************************************/




}