<?php
/**
 * Created by PhpStorm.
 * User: 123456
 * Date: 2017/1/10
 * Time: 16:22
 */

namespace Frontend\Model;

use Common\Data\StateData as SD;
use Frontend\Model\BusinessModel;
use Common\Aide\AgentAide;
use Common\Data\GiantAPIParamsData as GD;
use Frontend\Model\CloudstoragespaceModel;
use Frontend\Model\CloudstorageModel;
use Think\Exception;

/**
 * 对象存储空间文件
 * @date: 2018年11月2日
 * @author: gcf
 */
class CloudstoragespacefileModel extends BusinessModel{

	protected $trueTableName = 'agent_cloudstorage_space_file';
	/**
	 * 2018-11-01
	 * gcf
	 * $where条件
	 * */
	public function conver_par(){
		$date = request();
		$where["user_id"] = array("eq",session("user_id"));
		if(!empty($date['select'])){
			$select = clearXSS($date['select']);
			$map['api_bid'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map['nw_ip'] = array("like","%$select%");
			$map['_logic'] = 'OR';
			$map["beizhu"] = array("like","%$select%");
			$where['_complex'] = $map;
		}
		return $where;
	}


	/**
	 * 获取对象存储空间文件列表
	 * @date: 2018年11月02日
	 * @author: gcf
	 * @param $where
	 * @param $page
	 * @param string $order
	 * @return array|bool
	 */
	public function get_cloudstorage_spacefile_list($where,$per_page = 5,$order,$fields="*"){
		if(empty($order_by)){
			$order = 'DESC';
		}
		$info = [];
		if($where){
			$sum = $this->paging($where,$per_page,$fields,$order);
			$data = $this->queryBuilder($where,$fields,$order)
				->limit($sum['page']->firstRow.','.$sum['page']->listRows)->select();
			$info['count'] = $sum['count'];
			$info['show'] = $sum['page']->show();
			//对自带thinkphp分页进行替换
			$show = str_replace("<div>","",$info["show"]);
			$show = str_replace("</div>","",$show);
			$show = str_replace("span","a",$show);
			$info['page_show'] = $show;
			$info['list'] = $data;
			return $info;
		}else{
			$this->error = "查询条件为空";
			return false;
		}
	}

	/**
	 * 创建文件夹
	 * @date: 2018年11月12日
	 * @author: gcf
	 * @param 业务id：$yid,空间名称：$space_name,文件夹名称：$folder_name
	 */
	public function createfloder($yid,$space_name,$folder_name,$file_fid){
		/*if(!$yid || !$ywbs){
			return "业务编号或业务标识错误！";
		}*/
		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);

		$flouder['bucketName']=$space_name;
		$flouder['folderName']=$file_fid?$this->getforendfile($file_fid).$folder_name:$folder_name;
		$flouder['accessKey']=$cloudstoragebs['access_key'];
		$flouder['secretKey']=$cloudstoragebs['secret_key'];

		$info="bucketName:".$space_name."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—folderName:".$flouder['folderName'];

		$path="restful/storageapi/folder/createFolder";//创建文件夹接口地址
		try{
			$result = jiekou_storage($flouder,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】创建文件夹[".$folder_name."]，业务编号：[".$yid.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】创建文件夹[".$folder_name."]，业务编号：[".$yid.']');
		}
	//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,创建文件夹接口调用成功，根据返回创建成功信息*/
				return -1;
		}else{  //创建文件夹接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}

	/**
	 * 删除文件夹
	 * gcf 2018-11-15
	 */
	public function delflouder($yid,$space_id,$space_name,$file_fname,$file){
		$cloudstroage=new CloudstorageModel();
		$cloudstoragebs=$cloudstroage->getuserkey($yid);
		if($cloudstoragebs['user_id']!=session('user_id')){
			echo json_encode(['status'=>-2,'msg'=>"当前业务与会员信息不匹配，请合理操作！"]);exit;
		}
		$cloudstoragespace=new CloudstoragespaceModel();
		$spaceinfo=$cloudstoragespace->getspaceinfo($space_id);
		if($spaceinfo['space']!=$space_name){
			echo json_encode(['status'=>-2,'msg'=>"空间名称与空间id不匹配，请合理操作！"]);exit;
		}
		//删除文件夹参数
		$del['bucketName']=$space_name;
		$del['accessKey']=$cloudstoragebs['access_key'];
		$del['secretKey']=$cloudstoragebs['secret_key'];
		$del['folderName']=$file_fname;
		$endstr=substr($del['folderName'],'-1');
		if($endstr==="/"){
			$del['folderName']=rtrim($del['folderName'],'/');
		}
	 // 	var_dump($del);exit;
		$info="bucketName:".$space_name."—folderName:".$file_fname."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key'];
		$path="restful/storageapi/folder/deleteFolder";//删除文件夹接口地址
		try{
			$result = jiekou_storage($del,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】删除文件夹[".$file."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】删除文件夹[".$file."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,删除文件夹接口调用成功，根据返回创建成功信息*/
				return -1;
		}else{  //删除文件夹接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}
	/**
	 * 删除文件
	 * gcf 2018-11-21
	 */
	public function delfile($yid,$space_id,$space_name,$file_fname,$file){
		$cloudstroage=new CloudstorageModel();
		$cloudstoragebs=$cloudstroage->getuserkey($yid);
		if($cloudstoragebs['user_id']!=session('user_id')){
			echo json_encode(['status'=>-2,'msg'=>"当前业务与会员信息不匹配，请合理操作！"]);exit;
		}
		$cloudstoragespace=new CloudstoragespaceModel();
		$spaceinfo=$cloudstoragespace->getspaceinfo($space_id);
		if($spaceinfo['space']!=$space_name){
			echo json_encode(['status'=>-2,'msg'=>"空间名称与空间id不匹配，请合理操作！"]);exit;
		}
		//删除文件夹参数
		$del['bucketName']=$space_name;
		$del['accessKey']=$cloudstoragebs['access_key'];
		$del['secretKey']=$cloudstoragebs['secret_key'];
		$del['fileName']=$file_fname;
		$endstr=substr($del['folderName'],'-1');
		if($endstr==="/"){
			$del['folderName']=rtrim($del['folderName'],'/');
		}
		// 	var_dump($del);exit;
		$info="bucketName:".$space_name."—folderName:".$file_fname."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key'];
		$path="restful/storageapi/file/deleteFile";//删除文件接口地址
		try{
			$result = jiekou_storage($del,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】删除文件[".$file."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】删除文件[".$file."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,删除文件夹接口调用成功，根据返回创建成功信息*/
			return -1;
		}else{  //删除文件夹接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}
	/**
	 * 文件上传
	 * gcf  2018-11-19
	 */
	public function upload($data){
		header("Content-Type: application/json; charset=utf-8;");
		$cloudstroage=new CloudstorageModel();
		$cloudstoragebs=$cloudstroage->getuserkey($data['yid']);
		if($data['file_fid']){
			$fileName=$this->getforendfile($data['file_fid']).$data['name'];
		}else{
			$fileName=$data['name'];
		}

		//上传文件接口参数
		$upload['bucketName']=$data['space'];
		$upload['accessKey']=$cloudstoragebs['access_key'];
		$upload['secretKey']=$cloudstoragebs['secret_key'];
		$upload['input']=file_get_contents($data['tmp_name']);
		$upload['length']=strlen(file_get_contents($data['tmp_name']));
		$upload['fileName']=base64_encode($fileName);//base64_encode($fileName)

		$params=array(
		 	"bucketName:".$upload['bucketName'],
			"accessKey:".$upload['accessKey'],
			"secretKey:".$upload['secretKey'],
			"length:".$upload['length'],
			"fileName:".$upload['fileName']
		);

		$info="bucketName:".$data['space']."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—length:".$upload['length'];
		$path="restful/storageapi/file/uploadFile";//上传文件接口地址
		try{
			$result = jiekou_filestorage($params,$path,$upload['input']);
			api_log(session("user_id"),$info,$result,"【云存储】上传文件[".$data['name']."]，业务编号：[".$data['yid'].']，所属空间:['.$data['space'].']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】上传文件[".$data['name']."]，业务编号：[".$data['yid'].']，所属空间:['.$data['space'].']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,上传文件接口调用成功，根据返回创建成功信息*/
			return -1;
		}else{  //上传文件接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}

	/**
	 * @param $sapce_name
	 * @param $str_urls
	 * gcf 2018-11-27
	 */
	public function refreshurls($sapce_name,$str_urls,$yid){


	 	$arr_urls=explode(',',$str_urls);//var_dump($arr_urls);die;
		$path="restful/storageapi/access/refreshUrl";//刷新缓存接口地址
		$getparams='';

		$info="url:刷新缓存";

		  try{
			  $result = jiekou_storage(['url'=>$arr_urls[0]],$path,1,$getparams);
			  api_log(session("user_id"),$info,$result,"【云存储】刷新缓存，空间名称：[".$sapce_name."]，业务编号：[".$yid."]");
		  }catch(\Exception $e){
			  api_log(session("user_id"),$info,$e->getMessage(),"【云存储】刷新缓存，空间名称：[".$sapce_name."]，业务编号：[".$yid."]");
		  }

		  return -1;

	}
	/**
	 *  分页
	 * @date: 2018年11月2日
	 * @author: gcf
	 */
	public function paging($where,$per_page = 5,$fields,$order){
		$sumpage = [];
		$count = $this->queryBuilder($where,$fields,$order)->count();
		$Page = new \Think\Page($count,$per_page);// 实例化分页类 传入总记录数和每页显示的记录数
		$Page->setConfig('prev','上一页');
		$Page->setConfig('next','下一页');
		$Page->setConfig("first","首页");
		$Page->setConfig("last","尾页");
		$date = request();
		//分页跳转的时候保证查询条件
		foreach($date as $key => $val){
			$Page->parameter[$key] = urlencode($val);
		}
		$sumpage['page'] = $Page;
		$sumpage['count'] = $count;
		return $sumpage;
	}

	/**
	 * 获取带条件的总记录数
	 * @date: 2018年11月1日
	 * @author: gcf
	 */
	public function queryBuilder($where,$field="",$order_by = "DESC"){
		return $this->field($field)->where($where)->order("createtime ".$order_by);//返回带条件的总记录数;
	}

	/**
	 * 重命名文件夹
	 * gcf 2018-11-13
	 */
	public function renamefloder($data){
		$yid=$data['yid'];
		$space_name=$data['bucketName'];
		$oldname=$data['Filename'];
		$newname=$data['newfoldername'];
		$type=$data['type'];//1文件夹  2文件
		$file_id=$data['file_id'];//要修改的数据id

		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);
		if($cloudstoragebs['user_id']!=session('user_id')){
			return "当前业务与会员信息不匹配，请合理操作！";
		}
		if(empty($space_name)){
			return "空间不存在！";
		}
		if(empty($newname)){
			return "新名称不能为空！";
		}
		//获取路径
		$fileinfo=$this->where(['id'=>$file_id])->field('id,file_fid,file,type')->find();//要修改的数据信息
		if($fileinfo['file_fid']){
				$fname=$fileinfo['file'];
				$res=$this->getforendfile($fileinfo['file_fid']);
				$oldpath=$res.$fname;
				$newpath=$res.$newname;
		}else{
				$oldpath=$fileinfo['file'];
				$newpath=$newname;
		}

		//调用空间名称是否存在接口参数。。。。
		$rename['bucketName']=$space_name;
		$rename['accessKey']=$cloudstoragebs['access_key'];
		$rename['secretKey']=$cloudstoragebs['secret_key'];
		$rename['oldFolderName']=$oldpath;
		$rename['newFolderName']=$newpath;

		$info="bucketName:".$space_name."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—oldFolderName:".$oldpath."—newFolderName:".$newpath;

		$path="restful/storageapi/folder/renameFolder";//文件夹重命名接口地址
		try{
			$result = jiekou_storage($rename,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】重命名文件夹[".$oldpath."]->[".$newpath."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】重命名文件夹[".$oldpath."]->[".$newpath."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,重命名文件夹接口调用成功，根据返回信息，重命名文件夹成功*/
				return -1;
		}else{  //重命名文件夹接口调用失败，返回错误信息
			return $xstr["message"];
		}

	}
	/**
	 * 重命名文件
	 * gcf 2018-11-20
	 */
	public function renamefile($data){
		$yid=$data['yid'];
		$space_name=$data['bucketName'];
		$oldname=$data['Filename'];
		$newname=$data['newfoldername'];
		$type=$data['type'];//1文件夹  2文件
		$file_id=$data['file_id'];//要修改的数据id

		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);
		if($cloudstoragebs['user_id']!=session('user_id')){
			return "当前业务与会员信息不匹配，请合理操作！";
		}
		if(empty($space_name)){
			return "空间不存在！";
		}
		if(empty($newname)){
			return "新名称不能为空！";
		}
		//获取路径
		$fileinfo=$this->where(['id'=>$file_id])->field('id,file_fid,file,type')->find();//要修改的数据信息
		if($fileinfo['file_fid']){
			$fname=$fileinfo['file'];
			$res=$this->getforendfile($fileinfo['file_fid']);
			$oldpath=$res.$fname;
			$newpath=$res.$newname;
		}else{
			$oldpath=$fileinfo['file'];
			$newpath=$newname;
		}

		//调用空间名称是否存在接口参数。。。。
		$rename['bucketName']=$space_name;
		$rename['accessKey']=$cloudstoragebs['access_key'];
		$rename['secretKey']=$cloudstoragebs['secret_key'];
		$rename['oldFileName']=$oldpath;
		$rename['newFileName']=$newpath;

		$info="bucketName:".$space_name."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—oldFolderName:".$oldpath."—newFolderName:".$newpath;

		$path="restful/storageapi/file/renameFile";//文件重命名接口地址
		try{
			$result = jiekou_storage($rename,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】重命名文件[".$oldpath."]->[".$newpath."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】重命名文件[".$oldpath."]->[".$newpath."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,重命名文件夹接口调用成功，根据返回信息，重命名文件夹成功*/
			return -1;
		}else{  //重命名文件夹接口调用失败，返回错误信息
			return $xstr["message"];
		}
	}
	/**
	 * 获取文件路径
	 * gcf 2018-11-21
	 */
	public function getfileUrl($data){
		$yid=$data['yid'];
		$space_name=$data['space_name'];
		$space_id=$data['space_id'];
		$filename=$data['filename'];
		$file_id=$data['file_id'];
		$file_fid=$data['file_fid'];
		$cloudstoragespace=new CloudstoragespaceModel();
		$cloudstorage=new CloudstorageModel();
		$cloudstoragebs=$cloudstorage->getuserkey($yid);
		if($cloudstoragebs['user_id']!=session('user_id')){
			echo json_encode(['status'=>-2,'msg'=>"当前业务与会员信息不匹配，请合理操作！"]);exit;
		}
		$spaceinfo=$cloudstoragespace->getspaceinfo($space_id);
		if($spaceinfo['yid']!=$yid){
			echo json_encode(['status'=>-2,'msg'=>"空间与所属业务不匹配！请合理操作！"]);exit;
		}
		if(empty($space_name)){
			echo json_encode(['status'=>-2,'msg'=>"空间名称参数错误！".$space_name]);exit;
		}
		if(empty($filename)){
			echo json_encode(['status'=>-2,'msg'=>"文件名称参数错误！"]);exit;
		}

		//获取路径
		$fileinfo=$this->where(['id'=>$file_id])->field('id,file_fid,file,type')->find();//要修改的数据信息
		if($fileinfo['file_fid']){
			$fname=$fileinfo['file'];
			$res=$this->getforendfile($fileinfo['file_fid']);
			$filepath=$res.$fname;
		}else{
			$filepath=$fileinfo['file'];
		}

		//获取文件路径接口参数
		$geturl['accessKey']=$cloudstoragebs['access_key'];
		$geturl['secretKey']=$cloudstoragebs['secret_key'];
		$geturl['bucketName']=$space_name;
		$geturl['fileName']=$filepath;
	 	$geturl['leng']=0;
		$geturl['minutes']=0;

		$info="bucketName:".$space_name."—accessKey:".$cloudstoragebs['access_key']."—secretKey:".$cloudstoragebs['secret_key']."—fileName:".$filepath;

		$path="restful/storageapi/file/getFileUrl";//获取文件路径接口地址
		try{
			$result = jiekou_storage($geturl,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】获取文件路径[".$filename."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】获取文件路径[".$filename."]，业务编号：[".$yid.']，所属空间:['.$space_name.']');
		}
		//  var_dump($result);exit;
		$xstr = json_decode($result,true);
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,获取文件路径接口调用成功，根据返回信息*/
			return ['status'=>'-1','msg'=>$xstr['message']];
		}else{  //,获取文件路径接口调用失败，返回错误信息
			return ['status'=>$xstr["code"],'msg'=>$xstr["message"]];
		}

	}

	/**
	 * 同步当前目录下子目录及文件
	 * @param $accessKey
	 * @param $secretKey
	 * @param $bucketName
	 * @param $yid
	 * @return array
	 * gcf  2018-11-26
	 */
	public function tongfiles($accessKey,$secretKey,$bucketName,$yid,$file_fname){
		 $tong['accessKey']=$accessKey;
		 $tong['secretKey']=$secretKey;
		 $tong['bucketName']=$bucketName;
		 $tong['folderName']=$file_fname;
		 $tong['isGetFile']=true;

		$info="accessKey:".$accessKey."—secretKey:".$secretKey."—bucketName:".$bucketName."—folderName:".$file_fname;
		$path="restful/storageapi/folder/getSubFoldersAndFiles";//获取当前目录下子目录及其文件接口地址

		try{
			$result = jiekou_storage($tong,$path,1);
			api_log(session("user_id"),$info,$result,"【云存储】同步列表，业务编号：[".$yid."]");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】同步列表，业务编号：[".$yid."]");
		}
		/*输出接口结果***********/
		// var_dump($result);exit;

		$xstr = json_decode($result,true);
		// var_dump($xstr);exit;
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,获取所有空间接口调用成功，根据返回信息，*/
			return ['code'=>-1,'msg'=>$xstr["message"]];
		}else{  //创建空间接口调用失败，返回错误信息
			return ['code'=>-2,'msg'=>$xstr["message"]];
		}

	}

	/**
	 * 同步空间下所有文件/夹  弃用
	 * gcf 2018-11-26
	 */
	public function tongallfiles($accessKey,$secretKey,$bucketName,$yid){
		//同步空间下的文件接口参数
		$getparams="&accessKey=".$accessKey."&secretKey=".$secretKey."&bucketName=".$bucketName."&folderName=";
		$info="accessKey:".$accessKey."—secretKey:".$secretKey."—bucketName:".$bucketName."—folderName:";

		$path="restful/storageapi/file/allFileList";//获取所有空间下或者文件夹下所有对象列表接口地址

		try{
			$result = jiekou_storage(array(),$path,2,$getparams);
			api_log(session("user_id"),$info,$result,"【云存储】同步列表，业务编号：[".$yid."]");
		}catch(\Exception $e){
			$message = $e->getMessage();
			api_log(session("user_id"),$info,$message,"【云存储】同步列表，业务编号：[".$yid."]");
		}
		/*输出接口结果***********/
		 // var_dump($result);exit;

		$xstr = json_decode($result,true);
		//var_dump($xstr);exit;
		if($xstr["code"]==0 && $xstr["code"]!==null){
			/*code=0,获取所有空间接口调用成功，根据返回信息，*/
			return ['code'=>-1,'msg'=>$xstr["message"]];
		}else{  //创建空间接口调用失败，返回错误信息
			return ['code'=>-2,'msg'=>$xstr["message"]];
		}

	}

	/**
	 * 获取父文件/夹名称
	 * @param 文件父id
	 * gcf 2018-11-14
	 */
	public function getforendfile($file_fid){
		$info=$this->where(['id'=>$file_fid])->field('id,file_fid,file,type')->find();
		$fname=$info['file']."/";
		if($info['file_fid']){
			$infos=$this->where(['id'=>$info['file_fid']])->field('id,file_fid,file,type')->find();
			$fname=$infos['file']."/".$fname;
			if($infos['file_fid']){
				$infoss=$this->where(['id'=>$infos['file_fid']])->field('id,file_fid,file,type')->find();
				$fname=$infoss['file']."/".$fname;
				if($infoss['file_fid']){
					$infosss=$this->where(['id'=>$infoss['file_fid']])->field('id,file_fid,file,type')->find();
					$fname=$infosss['file']."/".$fname;
					if($infosss['file_fid']){
						$infossss=$this->where(['id'=>$infosss['file_fid']])->field('id,file_fid,file,type')->find();
						$fname=$infossss['file']."/".$fname;
						if($infossss['file_fid']){
							$infosssss=$this->where(['id'=>$infossss['file_fid']])->field('id,file_fid,file,type')->find();
							$fname=$infosssss['file']."/".$fname;
							if($infosssss['file_fid']){
								$infossssss=$this->where(['id'=>$infosssss['file_fid']])->field('id,file_fid,file,type')->find();
								$fname=$infossssss['file']."/".$fname;
								if($infossssss['file_fid']){
									$infosssssss=$this->where(['id'=>$infossssss['file_fid']])->field('id,file_fid,file,type')->find();
									$fname=$infosssssss['file']."/".$fname;
									if($infosssssss['file_fid']){
										$infossssssss=$this->where(['id'=>$infosssssss['file_fid']])->field('id,file_fid,file,type')->find();
										$fname=$infossssssss['file']."/".$fname;
										if($infossssssss['file_fid']){
											$infosssssssss=$this->where(['id'=>$infossssssss['file_fid']])->field('id,file_fid,file,type')->find();
											$fname=$infosssssssss['file']."/".$fname;
											if($infosssssssss['file_fid']){
												$infossssssssss=$this->where(['id'=>$infosssssssss['file_fid']])->field('id,file_fid,file,type')->find();
												$fname=$infossssssssss['file']."/".$fname;
												return $fname;
											}else{
												return $fname;
											}
										}else{
											return $fname;
										}
									}else{
										return $fname;
									}
								}else{
									return $fname;
								}
							}else{
								return $fname;
							}
						}else{
							return $fname;
						}
					}else{
						return $fname;
					}
				}else{
					return $fname;
				}
			}else{
				return $fname;
			}
		}else{
			return 	$fname;
		}


	}

	/****************************************************************************/




}